import { QoreClient } from "@qorebase/client";
import createQoreContext from "@qorebase/react";
import Cookies from "js-cookie";
import getConfig from "next/config";
const { serverRuntimeConfig, publicRuntimeConfig } = getConfig();
const isServer = typeof window === "undefined";
const BASE_URL = process.env.NODE_ENV === "development" && !isServer
    ? "/api/backend"
    : publicRuntimeConfig.qoreDataConsoleEndpoint;
export const qoreConfig = {
    endpoint: BASE_URL,
    adminSecret: serverRuntimeConfig.qoreDataConsoleAdminSecret,
    getToken: () => Cookies.get("token"),
};
const client = new QoreClient(qoreConfig);
client.project.axios.defaults.headers["x-qore-engine-admin-secret"] =
    qoreConfig.adminSecret;
const qoreStorageClient = createQoreContext(client);
export default qoreStorageClient;
//# sourceMappingURL=qoreStorageClient.js.map